var fmt = require('./format')
var fs = require('fs')
var toml = require('toml-js')
var Promise = require('bluebird')

module.exports = function (args) {
  Promise.promisifyAll(fs)
  var cName = args._[1]
  fmt.normal('checking for problems...')
  if (!cName) {
    fmt.error('no crate name supplied!')
  }

  fs.readFileAsync(process.cwd() + '/Cargo.toml', 'utf-8')
    .then(function (data) {
      var cToml = toml.parse(data)
      if (!cToml.dependencies) {
        fmt.error('hey! your Cargo.toml has no dependencies at all, what are you trying to remove?')
      }
      if (!cToml.dependencies[cName]) {
        fmt.error('the crate you want to remove isn\'t even installed!')
      }
      delete cToml.dependencies[cName]
      var result = toml.dump(cToml)
      return fs.writeFileAsync(process.cwd() + '/Cargo.toml', result, 'utf-8')
    }, function (e) {
      fmt.error(e)
    }).then(function () {
      fmt.success(cName + ' has been successfully removed from your Cargo.toml!')
    }, function (e) {
      fmt.error(e)
    }).catch(function (e) {
      fmt.error(e)
    })
}
